DEFINT A-Z

'----------------------------------------------------------------------------
'          CONBASE-Abfrage-Rumpfprogramm   Version 3.1  01.10.96
'----------------------------------------------------------------------------

'QBASIC-Programm zur Einbindung des Anwender-Abfrageprogramms.

'Die Subroutine zur Einbindung des Abfrageprogramms ist 'Abfrageprogramm'.

'Systemteile des Programms drfen in keinem Fall verndert werden.
'In diesem Programm vorhandene Anwenderteile sollten Sie nicht ndern.
'Anwenderroutinen knnen Sie beliebig hinzufgen.

'Die System- und Anwenderteile sind jeweils gekennzeichnet.

'Die globalen Variablen und Namen dieses Hauptprogramms sind alle lnger
'als 8 Zeichen, um Kollisionen mit den Feldnamen des Abfrageprogramms
'auszuschlieen.

'Sie knnen Ihre zustzlichen Programmteile testen, indem Sie im Unter-
'programm 'Abfrageprogramm' Ausgaben auf den Schirm vornehmen. Solche
'Testausgaben mssen Sie vor der Rckspeicherung des Programms natrlich
'wieder entfernen.

'Zum Austesten Ihrer nderungen sollten Sie eine Testdatenbank bzw.
'Testgruppe einrichten.

'Sie mssen prfen, ob alle in der Maske ausgewhlten Feldtypen auch von
'Ihrem Basic-Interpreter ausgewertet werden knnen. Wenn Sie in diesem
'Programm nach dem String 'Whrung' suchen, finden Sie die beiden
'entsprechenden Stellen, wo der in QBASIC nicht zur Verfgung stehende
'Feldtyp 'Currency' auskommentiert ist. Diese Auskommentierung knnen
'Sie aufheben.


'--------------------------- System-Routinen --------------------------------

DECLARE SUB Abfrageprogramm ()                       'Anwender-Abfrageprogramm
DECLARE SUB SatzKomprimieren (rec$)                  'Datensatz komprimieren
DECLARE SUB SatzExpandieren ()                       'Datensatz expandieren
DECLARE SUB TextPositionieren (text$, laenge, mode$) 'Text im Feld positionieren
DECLARE SUB DefFileLesen (file$)                     'Definitionsfile einlesen
DECLARE SUB Datumformat ()                           'Formatnderung akt. Datum
DECLARE SUB WertRunden (Feld$, mode$)                'Real, Double, Currency runden
DECLARE SUB ParLesen (variable$)                     'Parameter einlesen
DECLARE SUB Farbauswahl (Farbnummer)                 'Farbe auswhlen

'-------------------------- Anwender-Routinen -------------------------------

'Folgende Routinen knnen vom Abfrageprogramm aus aufgerufen werden:

DECLARE SUB ScreenError (x$)                  'Fehler auf Schirm ausgeben
DECLARE SUB FileError (x$)                    'Fehler in Datei #1 ausgeben
DECLARE SUB Leerstrich (x$)                   'Strich fr leeres Feld
DECLARE SUB Seitenvorschub ()                 'Seitenvorschub ausgeben
                                           
DECLARE FUNCTION TrimString$ (x$)             'String trimmen
DECLARE FUNCTION Vorhanden (x$)               'TRUE: String leer, sonst FALSE
DECLARE FUNCTION Datumvergleich$ (x1$, x2$)   'Vergleich Datum x1$, x2$


'------------------------- System-Konstanten --------------------------------

CONST TRUE = -1                        'Logischer Wert Wahr
CONST FALSE = NOT TRUE                 'Logischer Wert Falsch

CONST MAXFELDER = 255                  'Max. Anzahl von Definitionsfeldern
CONST MAXGLOBAL = 255                  'Max. Anzahl von Zwischenvariablen

CONST LAENGENUMMER = 5                 'Lnge der Satznummer als String

CONST PARAMETERDATEI$ = "dbank.ini"    'Datei mit Programmparametern (ohne Pfadangabe)
CONST RETURNNAME$ = "dbank"            'Dateiname des Returnprogramms
CONST DEFFILETYP$ = "def"              'Dateityp der Definitiondatei
CONST DATENFILETYP$ = "dc"             'Dateityp der Datendatei ohne Datenindex
CONST ERGEBNISFILETYP$ = "res"         'Dateityp der Ergebnisdatei
CONST TEMPORAERNAME$ = "dbank.tmp"     'Dateiname der temporren Datendatei
CONST MARKERFILENAME$ = "domacro.tmp"  'Dateiname der Markerdatei zur Makroausfhrung

CONST DEFAULTFORMAT$ = "\letjjjjjjjjxj\\\\"   'Default-Format fr Felder


'------------------------ Anwender-Konstanten -------------------------------



'----------------------- System-Einstellungen -------------------------------

CLEAR , , 4096                       'Grerer Stack

REM $DYNAMIC                         'Dynamische Felder


'------------------------- System-Variablen ---------------------------------

DIM SHARED Feldanzahl                'Anzahl der Felddefinitionen

DIM SHARED Bildnummer(MAXFELDER)     'Bildnummer
DIM SHARED Feldzeile(MAXFELDER)      'Zeilennummer des Feldes
DIM SHARED Feldspalte(MAXFELDER)     'Spaltennummer des Feldes
DIM SHARED Feldtypnummer(MAXFELDER)  'Feldtyp
DIM SHARED Feldlaenge(MAXFELDER)     'Feldlnge
DIM SHARED Feldtexte$(MAXFELDER)     'Feldtext
DIM SHARED Feldformate$(MAXFELDER)   'Feldformat
DIM SHARED Feldwerte$(MAXFELDER)     'Dummy

DIM SHARED Datenfeld$(MAXFELDER)     'Inhalte der Datenfelder

DIM SHARED Datensatz$           'Aktueller Datensatz (komprimiert)
DIM SHARED Satznummer$          'Aktuelle Satznummer
DIM SHARED MacroStart           'Return-Code fr CONBASE-Makro
DIM SHARED MacroControl$        'Variable zur Steuerung des Abfragemakros

DIM SHARED ErsterSatz           'TRUE: erster Satz in Bearbeitung
DIM SHARED LetzterSatz          'TRUE: letzter Satz in Bearbeitung
DIM SHARED Rueckschreiben       'TRUE: Datei wird zurckgeschrieben
DIM SHARED AlterSatz            'TRUE: Alter Satz wird zurckgeschrieben
DIM SHARED SatzLoeschen         'TRUE: Aktueller Satz wird gelscht
DIM SHARED Programmende         'TRUE: Programm wird abgebrochen
DIM SHARED Programmstart        'TRUE: Programm wird neu gestartet
DIM SHARED AktuellesDatum$      'Aktuelles Datum Format jjjjmmtt
DIM SHARED Gruppenpfad$         'Gruppenpfad, z.B. 'c:\conbase\demo\demo'
DIM SHARED Editoraufruf$        'Editor-Aufruf (Programmparameter)
DIM SHARED PurgeDateityp$       'Purge-Dateityp (Programmparamater)
DIM SHARED Farbwerte$           'Zeichenkette mit den Farbwerten

DIM SHARED NumerischesFeld(MAXFELDER)  'TRUE = numerische Variable
DIM SHARED LeeresFeld(MAXFELDER)       'TRUE = Feld war Leerstring

DIM SHARED Global$(0 TO MAXGLOBAL)     'Globale String-Variablen
DIM SHARED Global(0 TO MAXGLOBAL)      'Globale Integer-Variablen
DIM SHARED Global&(0 TO MAXGLOBAL)     'Globale Long-Integer-Variablen
DIM SHARED Global!(0 TO MAXGLOBAL)     'Globale Real-Variablen
DIM SHARED Global#(0 TO MAXGLOBAL)     'Globale Double-Variablen
'Whrung
'--DIM SHARED Global@(0 TO MaxGlobal)     'Globale Currency-Variablen


'------------------------- Anwender-Variablen -------------------------------




'----------------------------------------------------------------------------
'    Das folgende Hauptprogramm darf vom Anwender nicht verndert werden
'----------------------------------------------------------------------------

'Globale Variablen zurcksetzen

FOR i = 1 TO MAXGLOBAL
 
  'Feldtypen

  Global$(i) = ""
  Global(i) = 0
  Global&(i) = 0&
  Global!(i) = 0!
  Global#(i) = 0#
  'Whrung
  '--Global@(i) = 0@

NEXT i


'Initialisierungen

FOR i = 1 TO MAXFELDER
  NumerischesFeld(i) = FALSE
NEXT i

CALL Datumformat

'Programmparameter einlesen

OPEN PARAMETERDATEI$ FOR INPUT AS #1

  CALL ParLesen(Laufwerk$)
  CALL ParLesen(Verzeichnis$)
  CALL ParLesen(Datenbank$)
  CALL ParLesen(Gruppe$)
  CALL ParLesen(Datenindex$)
  CALL ParLesen(Programmverzeichnis$)
  CALL ParLesen(Temporaerverzeichnis$)
  CALL ParLesen(Abfragemodus$)
  CALL ParLesen(Returnlabel$)
  CALL ParLesen(Editoraufruf$)
  CALL ParLesen(PurgeDateityp$)
  CALL ParLesen(Farbwerte$)

CLOSE #1

Returnprogramm$ = Programmverzeichnis$ + "\" + RETURNNAME$
Returncode$ = "ok"
Gruppenpfad$ = Laufwerk$ + ":\" + Verzeichnis$ + "\" + Datenbank$ + "\" + Gruppe$
Definitionsfile$ = Gruppenpfad$ + "." + DEFFILETYP$
Datenfile$ = Gruppenpfad$ + "." + DATENFILETYP$ + Datenindex$
Ergebnisfile$ = Gruppenpfad$ + "." + ERGEBNISFILETYP$
Temporaerfile$ = Temporaerverzeichnis$ + "\" + TEMPORAERNAME$
Markerfile$ = Programmverzeichnis$ + "\" + MARKERFILENAME$

'Bildschirm initialisieren

VIEW PRINT
CALL Farbauswahl(1)
CLS

'Startmeldung
LOCATE 1, 1, 0
PRINT " Abfrageprogramm (" + UCASE$(Abfragemodus$) + ") luft ...  (ESC=Abbruch  F5=Neustart)"
PRINT STRING$(80, CHR$(196))

'Definitionsfile einlesen
CALL DefFileLesen(Definitionsfile$)

'Initialisierungen fr Ablaufsteuerung
Satznr = 1
ErsterSatz = TRUE
Fileuebernahme = FALSE
Rueckschreiben = FALSE
Nichtschreiben = FALSE
Programmende = FALSE
Programmstart = FALSE
MacroStart = FALSE
MacroControl$ = ""

CALL Farbauswahl(5)
LOCATE 1, 69
PRINT " " + UCASE$(Datenindex$);
CALL Farbauswahl(1)
LOCATE 4, 1

'Dateien ffnen

OPEN Datenfile$ FOR INPUT AS #99
OPEN Ergebnisfile$ FOR OUTPUT AS #1
OPEN Temporaerfile$ FOR OUTPUT AS #98

'Datenstze einlesen

DO WHILE EOF(99) = 0
 
  'Ausgabe der Nummer des bearbeiteten Satzes
  AlteZeile = CSRLIN: AlteSpalte = POS(1)
  VIEW PRINT
  CALL Farbauswahl(5)
  LOCATE 1, 71: PRINT USING "#######"; Satznr; : PRINT " ";
  CALL Farbauswahl(1)
  VIEW PRINT 3 TO 25
  LOCATE AlteZeile, AlteSpalte

  'Satz einlesen
  LINE INPUT #99, Datensatz$

  'Kennzeichnung, ob letzter Satz in Bearbeitung
  LetzterSatz = FALSE
  IF EOF(99) <> 0 THEN LetzterSatz = TRUE
 
  'Vorbesetzung, ob Satz gelscht werden soll
  SatzLoeschen = FALSE
 
  'Vorbesetzung, ob alter oder genderter Satz zurckgeschrieben werden soll
  AlterSatz = FALSE

  'Satz in Felder zerlegen
  CALL SatzExpandieren
 
  'Satznummer-Variable
  Satznummer$ = LTRIM$(RTRIM$(STR$(Satznr)))
  Satznummer$ = SPACE$(LAENGENUMMER - LEN(Satznummer$)) + Satznummer$
 
  'Nur regulre Stze auswerten
  IF LEFT$(Datensatz$, 1) = "r" THEN
   
    'Aufruf des Abfrageprogramms
    CALL Abfrageprogramm
   
    IF Programmende THEN
      PRINT
      PRINT " Abbruch des Programms"
      Fileuebernahme = FALSE
      Returncode$ = "abbruch"
      EXIT DO
    END IF

    IF Programmstart THEN
      'Neustart des Programms
      CLS : CLOSE : RUN
    END IF

    'beim ersten Durchlauf wird entschieden, ob die Daten wieder
    'geschrieben werden. Danach ist keine nderung mehr mglich.
    IF ErsterSatz AND NOT Rueckschreiben THEN Nichtschreiben = TRUE
   
    'Kennzeichnung, da erster Satz nicht mehr in Bearbeitung
    ErsterSatz = FALSE
   
    'Datensatz komprimieren und neu schreiben
    IF NOT Nichtschreiben THEN

      IF NOT SatzLoeschen THEN

        IF NOT AlterSatz THEN

          'Neuen Datensatz zurckschreiben

          CALL SatzKomprimieren(NeuerSatz$)
       
          'Prfen, ob der Datensatz verndert wurde
       
          IF NeuerSatz$ <> Datensatz$ THEN
            Fileuebernahme = TRUE
            'Aktuelles Datum eintragen
            MID$(NeuerSatz$, 3, 8) = AktuellesDatum$
          END IF
       
          PRINT #98, NeuerSatz$
     
        ELSE

          'Alten (eingelesenen) Datensatz zurckschreiben

          PRINT #98, Datensatz$

        END IF

      ELSE

        'Satz wird gelscht, damit die Datendatei verndert
        Fileuebernahme = TRUE

      END IF
   
    END IF

  END IF
 
  Satznr = Satznr + 1
 
  Taste$ = INKEY$
 
  IF Taste$ = CHR$(27) THEN
   
    PRINT
    PRINT " Abbruch des Programms durch Benutzereingabe"
    Fileuebernahme = FALSE
    Returncode$ = "abbruch"
    EXIT DO
 
  ELSEIF Taste$ = CHR$(0) + CHR$(63) THEN
   
    'Neustart
    CLS : CLOSE : RUN
 
  END IF

LOOP


'Alle geffneten Dateien schlieen
CLOSE

IF Returncode$ = "ok" THEN

  IF Fileuebernahme THEN
 
    'Datenstze wurden gendert, fragen, ob bernahme der nderungen

    CLS
    PRINT
    PRINT " Datenstze wurden durch das Abfrageprogramm verndert."
    PRINT
    PRINT " nderungen bernehmen ? (j/n)"
 
TasteEinlesen:
    Taste$ = LCASE$(INPUT$(1))

    IF Taste$ = "j" THEN
   
      PRINT
      PRINT " Genderte Daten werden bernommen ..."
      SHELL "copy " + Temporaerfile$ + " " + Datenfile$ + " > nul"

    ELSEIF Taste$ = "n" THEN

      PRINT
      PRINT " Genderte Daten werden nicht bernommen ..."

    ELSE

      GOTO TasteEinlesen

    END IF

  END IF


  'Datei fr Makro-Ausfhrung schreiben

  IF MacroStart THEN
    OPEN Markerfile$ FOR OUTPUT AS #1
      PRINT #1, MacroControl$ + " "
    CLOSE #1
  END IF

END IF


SHELL "del " + Temporaerfile$ + " > nul"


'Programmrckkehr in Abhngigkeit vom Aufruf

VIEW PRINT
COLOR 7, 0
CLS

IF Abfragemodus$ = "exe" THEN
   
  RUN Returnprogramm$ + " 3141 " + Returncode$ + " " + Returnlabel$
 
ELSE  'Abfragemodus$ = "bas"
   
  SYSTEM
 
END IF

'----------------------- Ende des Hauptprogramms ----------------------------

END

REM $STATIC
SUB Abfrageprogramm ()
'SYSTEM-ROUTINE zum Einsetzen des Abfrageprogramms

'Wenn Sie Testausgaben in dieses Unterprogramm schreiben, denken Sie bitte
'daran, diese wieder zu entfernen, bevor Sie das Programm speichern.

'includeall     (Diese Marker-Zeile zum Einsetzen der Abfrage nicht ndern!)


EXIT SUB
END SUB

SUB Datumformat ()
'SYSTEM-ROUTINE Aktuelles Datum in Format jjjjmmtt umwandeln

tmp$ = DATE$

AktuellesDatum$ = RIGHT$(tmp$, 4) + LEFT$(tmp$, 2) + MID$(tmp$, 4, 2)

EXIT SUB
END SUB

FUNCTION Datumvergleich$ (datum1$, datum2$)
'SYSTEM-ROUTINE Vergleich datum1$ mit datum2$

'Formate datum1$, datum2$: jjjjmmtt

'Rckgabewerte:  '<' : datum1$ < datum2$
                 '=' : datum1$ = datum2$
                 '>' : datum1$ > datum2$

IF datum1$ = datum2$ THEN
  Datumvergleich$ = "="
ELSEIF datum1$ < datum2$ THEN
  Datumvergleich$ = "<"
ELSE
  Datumvergleich$ = ">"
END IF

EXIT FUNCTION
END FUNCTION

SUB DefFileLesen (Definitionsfile$)
'SYSTEM-ROUTINE File mit Maskendefinitionen einlesen

OPEN Definitionsfile$ FOR INPUT AS #1

i = 1
DO WHILE EOF(1) = 0
 
  IF i > MAXFELDER THEN
    PRINT " Zu viele Definitionen. Konstante MaxFelder ndern."
    COLOR 7, 0
    END
  END IF
 
  'Definitionen fr ein Feld einlesen
  INPUT #1, Bildnummer(i), Feldzeile(i), Feldspalte(i), Feldtypnummer(i), Feldlaenge(i), Feldtexte$(i), Feldformate$(i), Feldwerte$(i)
 
  IF Feldtypnummer(i) > 0 THEN
   
    'Eingabefeld

    'Default-Format zuweisen, wenn kein Format angegeben
    IF Feldformate$(i) = "" THEN Feldformate$(i) = DEFAULTFORMAT$

    'Kennzeichnung, ob numerisches Feld
    a$ = MID$(Feldformate$(i), 4, 1)
    IF a$ = "i" OR a$ = "l" OR a$ = "r" OR a$ = "p" OR a$ = "c" THEN
      NumerischesFeld(i) = TRUE
    END IF

  ELSE
 
    'Textfeld, Lnge setzen
   
    Feldlaenge(i) = LEN(Feldtexte$(i))
 
  END IF

  i = i + 1

LOOP

CLOSE 1

'Gesamtzahl der Felder
Feldanzahl = i - 1

EXIT SUB
END SUB

SUB Farbauswahl (Farbnummer)
'SYSTEM-ROUTINE Farbe aus Farb-Zeichenkette auswhlen

'Parameter "Farbnummer":

'  1: Normalschrift
'  2: Reversschrift
'  3: Normal-Kennbuchstaben
'  4: Revers-Kennbuchstaben
'  5: Hervorhebungen
'  6: Entscheidungen

'In der Farben-Zeichenkette befinden sich die Farbwerte als Hexadezimal-
'zahlen (0,1,2,...,F) fr die Normalschrift, die Reversschrift, die
'Normal-Kennbuchstaben, die Revers-Kennbuchstaben, die Hervorhebungen und
'die Entscheidungen.

'Dabei ist jeweils das erste Zeichen der Farbwert fr die Vordergrundfarbe
'(0 bis F) und das zweite Zeichen der Farbwert fr die Hintergrundfarbe
'(0 bis 7).

'Parameter prfen

IF Farbnummer < 1 THEN EXIT SUB

hgrundpos = 2 * Farbnummer
vgrundpos = hgrundpos - 1

l = LEN(Farbwerte$)
IF hgrundpos > LEN(Farbwerte$) THEN EXIT SUB

'Farben ermitteln

vgrundfarbe = VAL("&H" + MID$(Farbwerte$, vgrundpos, 1))
hgrundfarbe = VAL("&H" + MID$(Farbwerte$, hgrundpos, 1))

IF vgrundfarbe = hgrundfarbe THEN EXIT SUB

'Farbe setzen

COLOR vgrundfarbe, hgrundfarbe

EXIT SUB
END SUB

SUB FileError (ausgabetext$)
'ANWENDER-ROUTINE Ausgabe einer Fehlermeldung in die Standard-Ausgabedatei

PRINT #1, "Fehler Satz " + LTRIM$(RTRIM$(Satznummer$)) + " : " + ausgabetext$

EXIT SUB
END SUB

SUB Leerstrich (x$)
'ANWENDER-ROUTINE Strich als erstes Zeichen ins Feld, wenn es leer ist

'Bei einer tabellarischen Ausgabe wird dann anstelle eines leeren Feldes
'ein Strich ausgegeben

IF x$ = SPACE$(LEN(x$)) THEN MID$(x$, 1, 1) = "-"

EXIT SUB
END SUB

SUB ParLesen (variable$)
'SYSTEM-ROUTINE Parameter einlesen, trimmen und in Lowercase umwandeln

INPUT #1, variable$

variable$ = LTRIM$(RTRIM$(LCASE$(variable$)))

EXIT SUB
END SUB

SUB SatzExpandieren ()
'SYSTEM-ROUTINE Satz in Felder zerlegen

'Suchbeginn auf erstes Zeichen setzen
s = 1

'Alle Felddefinitionen durchgehen
FOR i = 1 TO Feldanzahl

  IF Feldtypnummer(i) > 0 THEN
    'Feld ist Eingabefeld
  
    l = Feldlaenge(i)
    a = INSTR(s, Datensatz$, "\")
  
    IF a = 0 THEN
      'kein Backslash mehr vorhanden, Feld mu Leerfeld sein
     
      s$ = SPACE$(l)
      LeeresFeld(i) = TRUE
   
    ELSE
     
      'noch Backslash vorhanden
     
      'Feldinhalt aus Datensatz$ lesen
      s$ = MID$(Datensatz$, s, a - s)
     
      'Feld kappen, wenn zu lang
      IF LEN(s$) > l THEN s$ = LEFT$(s$, l)
     
      'Feldinhalt formatieren
      CALL TextPositionieren(s$, l, MID$(Feldformate$(i), 2, 1))
    
      'Merken, ob Feld leer ist
      LeeresFeld(i) = FALSE
      IF s$ = SPACE$(LEN(s$)) THEN LeeresFeld(i) = TRUE
     
      'Suchbeginn neu setzen
      s = a + 1
   
    END IF
  
    'Feldinhalt zuweisen
    Datenfeld$(i) = s$

  END IF

NEXT i

EXIT SUB
END SUB

SUB SatzKomprimieren (r$)
'SYSTEM-ROUTINE Satz komprimieren

'Backslashes fr alle letzten leeren Felder werden weggelassen
'Letztes Zeichen des Datensatzes mu immer ein Backslash sein

r$ = ""
flag = 0

FOR i = Feldanzahl TO 1 STEP -1
  IF Feldtypnummer(i) > 0 THEN
    'Eingabefeld
   
    'Vor- und Nachblanks entfernen
    Feld$ = LTRIM$(RTRIM$(Datenfeld$(i)))

    IF NumerischesFeld(i) THEN
     
      'Numerischen Wert Typ Real, Double oder Currency runden
      a$ = MID$(Feldformate$(i), 4, 1)
      IF a$ = "r" OR a$ = "p" OR a$ = "c" THEN
        CALL WertRunden(Feld$, MID$(Feldformate$(i), 13, 1))
      END IF
     
      'wenn numerisches Feld leer war und jetzt = 0 ist, wieder Leerstring
      IF LeeresFeld(i) AND VAL(Feld$) = 0 THEN
        Feld$ = ""
      END IF
   
    END IF

    'Feld anfgen
    IF Feld$ <> "" OR flag = 1 THEN
      r$ = Feld$ + "\" + r$
      flag = 1
    END IF
  
  END IF
NEXT i

EXIT SUB
END SUB

SUB ScreenError (ausgabetext$)
'ANWENDER-ROUTINE Ausgabe einer Fehlermeldung auf den Bildschirm

PRINT " Fehler Satz " + LTRIM$(RTRIM$(Satznummer$)) + " : " + ausgabetext$

EXIT SUB
END SUB

SUB Seitenvorschub ()
'ANWENDER-ROUTINE Seitenvorschub ausgeben

PRINT #1, CHR$(12)

EXIT SUB
END SUB

SUB TextPositionieren (text$, l, mode$)
'SYSTEM-ROUTINE Text im Feld positionieren

text$ = LTRIM$(RTRIM$(text$))

IF mode$ = "l" THEN
 
  'Linksbndig
  text$ = text$ + SPACE$(l - LEN(text$))

ELSEIF mode$ = "r" THEN
 
  'Rechtsbndig
  text$ = SPACE$(l - LEN(text$)) + text$

ELSEIF mode$ = "z" THEN
 
  'Zentriert
  a = l - LEN(text$)
  b = FIX(CSNG(a) / CSNG(2))
  c = a - b
  text$ = SPACE$(b) + text$ + SPACE$(c)

END IF

EXIT SUB
END SUB

FUNCTION TrimString$ (x$)
'ANWENDER-ROUTINE Vor- und Nachblanks abtrennen

TrimString$ = LTRIM$(RTRIM$(x$))

END FUNCTION

FUNCTION Vorhanden (rec$)
'ANWENDER-ROUTINE Prfen, ob String leer ist

IF LTRIM$(RTRIM$(rec$)) = "" THEN
 
  'String ist leer
  Vorhanden = FALSE

ELSE
 
  'String ist nicht leer
  Vorhanden = TRUE

END IF

EXIT FUNCTION
END FUNCTION

SUB WertRunden (Feld$, mode$)
'SYSTEM-ROUTINE Numerischen Wert Typ Real, Double oder Currency runden

'Exit, wenn freies Format
IF mode$ = "x" THEN EXIT SUB

'Anzahl der Nachkommastellen
mode = ASC(UCASE$(mode$)) - 65
IF mode < 0 THEN EXIT SUB

'Exponentialformate nicht verndern
IF INSTR(UCASE$(Feld$), "E") > 0 OR INSTR(UCASE$(Feld$), "D") > 0 THEN EXIT SUB

'Wert runden
xmode = mode
IF xmode = 0 THEN xmode = 1
x# = VAL(Feld$)
IF x# <> 0# THEN x# = SGN(x#) * (ABS(x#) + VAL("5E-" + STR$(xmode)))
x$ = LTRIM$(RTRIM$(STR$(x#)))
a = INSTR(x$, ".")

IF a <> 0 THEN
 
  'Dezimalzahl

  x$ = LEFT$(x$, a + mode - 1)
 
  'Letzte Nullen entfernen
 
  FOR i = LEN(x$) TO 1 STEP -1
    IF MID$(x$, i, 1) <> "0" THEN EXIT FOR
  NEXT i
  x$ = LEFT$(x$, i)
 
  'Dezimalpunkt entfernen, wenn letztes Zeichen
 
  IF RIGHT$(x$, 1) = "." THEN x$ = LEFT$(x$, LEN(x$) - 1)

END IF

Feld$ = x$

EXIT SUB
END SUB

